<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @contact		shyam@joomlaxi.com
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Default Subscription Plan Plugin
 */
class plgPayplansDefaultPlan extends XiPlugin
{
		// joomla 1.6 compatibility
		public function onUserBeforeSave($user, $isnew)
		{
			return $this->onBeforeStoreUser($user, $isnew);
		}

		/*
		 * if new user then maintain into session to avoid conflict with jspt process
		 */
		public function onBeforeStoreUser($user, $isnew)
		{
			if($isnew){
				XiFactory::getSession()->set('PLG_DEFAULT_PLAN_NEW_USER', true);
			}

			return true;
		}

		// Joomla 1.6 compatibility
		public function onAfterStoreUser($user, $new)	
		{
	 	    return $this->onUserAfterSave($user, $new);
		}
		
		function onUserAfterSave($user, $new)
		{
			$newUser = XiFactory::getSession()->get('PLG_DEFAULT_PLAN_NEW_USER', false);
			if($newUser === true)
			{
				XiFactory::getSession()->set('PLG_NEW_USER_DATA', $user);
			}
			return true;
		}


		public function onPayplansGetPlugin()
		    {
			$xml = dirname(__FILE__).DS.'defaultplan.xml';
			if (file_exists($xml)) {
			            $xmlContent = simplexml_load_file($xml);
			        }
			        else {
			            $xmlContent = null;
			        }
			 return array('name'   => 'defaultplan', 
			        	  'value' =>$xmlContent);
		    }

		function onAfterRoute()
		{
			//apply default subscription plan to new registered user
			$defaultPlan = $this->params->get('defaultPlan',0); 
			$newUser = XiFactory::getSession()->get('PLG_DEFAULT_PLAN_NEW_USER', false);
			$user = XiFactory::getSession()->get('PLG_NEW_USER_DATA');
		
			// Do Nothing in case of dummy user's craeted by Donation and oneclickCheckout App
			if(strtolower($user['name']) == 'donor_registered' || strtolower($user['name']) == 'not_registered'){
				return true;
			}

			if(($defaultPlan != 0) && ($newUser === true) && !empty($user)){
				$plan = PayplansPlan::getInstance($defaultPlan);
				XiFactory::getSession()->clear('PLG_DEFAULT_PLAN_NEW_USER');
				XiFactory::getSession()->clear('PLG_NEW_USER_DATA');
				$order = $plan->subscribe($user['id'])
				 	 	 ->save();
			
				$invoice = $order->createInvoice();
	
				//apply 100% discount
				$modifier = PayplansModifier::getInstance();
				$modifier->set('message', XiText::_('COM_PAYPLANS_SIGNUP_PLAN_TO_USER_MESSAGE' ))
					 ->set('invoice_id', $invoice->getId())
					 ->set('user_id', $invoice->getBuyer())
					 ->set('type', 'signup_plan')
					 ->set('amount', -100) // 100 percent Discount, discount must be negative
					 ->set('percentage', true) 
					 ->set('frequency', PayplansModifier::FREQUENCY_ONE_TIME)
					 ->set('serial', PayplansModifier::FIXED_DISCOUNT)
					 ->save();
					  
				$invoice->refresh()->save();
				
				// create a transaction with 0 amount 
				$transaction = PayplansTransaction::getInstance();
				$transaction->set('user_id', $invoice->getBuyer())
							->set('invoice_id', $invoice->getId())
							->set('message', 'COM_PAYPLANS_TRANSACTION_CREATED_FOR_SIGNUP_PLAN_TO_USER')
							->save();
	
				//trigger the event
				$args = array($transaction, 0);
				PayplansHelperEvent::trigger('onPayplansWalletUpdate', $args);
			}
			
			return true;
		}
}